#include "../stdafx.h"
#include "StandardInput.h"
#include "Player.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern TCHAR inDescription[50];

In_Module standardIn =
{
	0,  						//   module type (IN_VER)
	inDescription,  			//   description of module, with version string
	0,  						//   winamp's main window (filled in by winamp)
	0,  						//   DLL instance handle (Also filled in by winamp)
	_T("MP3\0MP3AudioFile(*.MP3)\0"),// " ""mp3\0Layer 3 MPEG\0mp2\0Layer 2 MPEG\0mpg\0Layer 1 MPEG\0"""
	1,  						//   is this stream seekable? 
	1,  						//   does this plug-in use the output plug-ins? (musn't ever change, ever :)
	InputConfig,				//   configuration dialog
	InputAbout, 				//   about dialog
	InputInit,  				//   called at program init
	Quit,   					//   called at program quit
	GetFileInfo,				//   if file == NULL, current playing is used
	InfoBox,					//  
	IsOurFile,  				//   called before extension checks, to allow detection of mms:
	Play,   					//   return zero on success, -1 on file-not-found, some other value on other (stopping winamp) error
	Pause,  					//   pause stream
	Resume, 					//   unpause stream
	IsPaused,   				//   ispaused? return 1 if paused, 0 if not
	Close,  					//   stop (unload) stream
	GetSize,					//   get length in ms
	GetPos, 					//   returns current output time in ms. (usually returns outMod->GetOutputTime()
	SetPos, 					//   seeks to point in stream (in ms). Usually you signal yoru thread to seek, which seeks and calls outMod->Flush()..
	SetVolume,  				//   from 0 to 255.. usually just call outMod->SetVolume
	InputSetPan,				//   from -127 to 127.. usually just call outMod->SetPan
	SAVSAInit,  				//   call once in Play(). maxlatency_in_ms should be the value returned from outMod->Open()
	SAVSADeInit,				//   call in Stop()
	SAAddPCMData,   			//  
	SAGetMode,  				//   gets csa (the current type (4=ws,2=osc,1=spec))
	SAAdd,  					//   sets the spec data, filled in by winamp
	VSAAddPCMData,  			//   sets the vis data directly from PCM data
	VSAGetMode, 				//   use to figure out what to give to VSAAdd
	VSAAdd, 					//   filled in by winamp, called by plug-in
	VSASetInfo, 				//  
	dsp_isactive,   			//  
	dsp_dosamples,  			//  
	EQSet,  					//   0-64 each, 31 is +0, 0 is +12, 63 is -12. Do nothing to ignore.
	SetInfo,					//   if -1, changes ignored? :)







};

CStandardInput::~CStandardInput()
{
}

CStandardInput::CStandardInput(CString dllPath, HWND hWnd) : InputInterface(dllPath)
{
	standardIn.hMainWindow = hWnd;
	standardIn.hDllInstance = AfxGetInstanceHandle();
}

void CStandardInput::Config(HWND hwndParent) // configuration dialog
{
	standardIn.Config(hwndParent);
}

void CStandardInput::About(HWND hwndParent)  // about dialog
{
	standardIn.About(hwndParent);
}

void CStandardInput::GetFileInfo(TCHAR* file, TCHAR* title, int* length_in_ms) // if file == NULL, current playing is used
{
	standardIn.GetFileInfo(file, title, length_in_ms);
}

int CStandardInput::InfoBox(TCHAR* file, HWND hwndParent)
{
	int res = standardIn.InfoBox(file, hwndParent);
	return res;
}

int CStandardInput::IsOurFile(TCHAR* fn)  // called before extension checks, to allow detection of mms://, etc
{
	int res = standardIn.IsOurFile(fn);
	return res;
}

// playback stuff
int CStandardInput::Play(TCHAR* fn)   // return zero on success, -1 on file-not-found, some other value on other (stopping winamp) error
{
	int res = standardIn.Play(fn);
	return res;
}

void CStandardInput::Pause()	  // pause stream
{
	standardIn.Pause();
}

void CStandardInput::UnPause()  	// unpause stream
{
	standardIn.UnPause();
}

int CStandardInput::IsPaused()     // ispaused? return 1 if paused, 0 if not
{
	int res = standardIn.IsPaused();
	return res;
}

void CStandardInput::Stop() 	  // stop (unload) stream
{
	standardIn.Stop();
}
// time stuff
int CStandardInput::GetLength() 	 // get length in ms
{
	int res = standardIn.GetLength();
	return res;
}

int CStandardInput::GetOutputTime()    // returns current output time in ms. (usually returns outMod->GetOutputTime()
{
	int res = standardIn.GetOutputTime();
	return res;
}

void CStandardInput::SetOutputTime(int time_in_ms)  // seeks to point in stream (in ms). Usually you signal yoru thread to seek, which seeks and calls outMod->Flush()..
{
	standardIn.SetOutputTime(time_in_ms);
}

// volume stuff
void CStandardInput::SetVolume(int volume)  // from 0 to 255.. usually just call outMod->SetVolume
{
	standardIn.SetVolume(volume);
}

void CStandardInput::SetPan(int pan)  // from -127 to 127.. usually just call outMod->SetPan
{
	standardIn.SetPan(pan);
}

// info setting (filled in by winamp)
void CStandardInput::SetInfo(int bitrate, int srate, int stereo, int synched) // if -1, changes ignored? :)
{
	standardIn.SetInfo(bitrate, srate, stereo, synched);
}

int CStandardInput::GetVersion()	   // module type (IN_VER)
{
	return standardIn.version;
}
TCHAR* CStandardInput::GetDescription() 	// description of module, with version string
{
	return standardIn.description;
}

void CStandardInput::SethMainWindow(HWND hWnd)    // winamp's main window (filled in by winamp)
{
	standardIn.hMainWindow = hWnd;
}
void CStandardInput::SethDllInstance(HINSTANCE hDLL)	// DLL instance handle (Also filled in by winamp)
{
}

TCHAR* CStandardInput::GetFileExtensions()   // "mp3\0Layer 3 MPEG\0mp2\0Layer 2 MPEG\0mpg\0Layer 1 MPEG\0"
{
	return standardIn.FileExtensions;
}

int CStandardInput::isSeekable()	 // is this stream seekable?
{
	return standardIn.is_seekable;
}

int CStandardInput::isUsesOutputPlug()     // does this plug-in use the output plug-ins? (musn't ever change, ever :)
{
	return standardIn.UsesOutputPlug;
}

void CStandardInput::SetOutMod(Out_Module* out) // filled in by winamp, optionally used :)
{
	standardIn.outMod = out;
}

In_Module* CStandardInput::GetIn_Module()
{
	return &standardIn;
}

