#include "common.h"
#include <io.h>
#include <fcntl.h>
#include "../stdafx.h"
#include <wininet.h>
#include <math.h>
#include <tchar.h>
#include "stream.h"
#include "args.h"
#include "player.h"
#include "dxhead.h"
#include "frame.h"
#include "FrameManager.h"
#include "in.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern MPArgs Args;
extern Frame fr;

/*--------------------XING STUFF-----------------------------*/
unsigned char TOC[100];
extern XHEADDATA X;

/*-------------------------------------------------------------*/


// Bitrate index,in order: MPEG version,layer,bitrate index 
const int BitRateIndex[2][3][16] =
{
	{
	{0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,},
	{0,32,48,56,64,80,96,112,128,160,192,224,256,320,384,},
	{0,32,40,48,56,64,80,96,112,128,160,192,224,256,320,}
	}, {
	{0,32,48,56,64,80,96,112,128,144,160,176,192,224,256,},
	{0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,},
	{0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,}
	}
};

const long freqs[9] =
{
	44100, 48000, 32000, 22050, 24000, 16000, 11025, 12000, 8000
};

struct ibuf
{
	struct ibuf* next;
	struct ibuf* prev;
	unsigned char* buf;
	unsigned char* pnt;
	int len;
};

struct ibuf ibufs[2];
struct ibuf* cibuf;
#define TAILLEBS 4
unsigned char bsspace[TAILLEBS][MAXFRAMESIZE + 512];
unsigned char* bsbuf = bsspace[0];
unsigned char* bsbufold;
static HGLOBAL MBHnd;

FrameManager* frames = NULL;
unsigned char* bodies;
bool* results;

int bitindex;
unsigned char* wordpointer;
HANDLE StreamHandle;
unsigned long StreamSize;
int ibufnum, fsize, fsizeold, ssize, bsnum;
unsigned long oldhead, firsthead;
esInputMode InputMode;

bool StreamInit = false;

extern In_Module standardIn;

#define swap_int32(int_32) (((int_32) << 24) | (((int_32) << 8) & 0x00ff0000) | \
						 (((int_32) >> 8) & 0x0000ff00) | ((int_32) >> 24))

unsigned long Currentms()
{
	return Args.CurrentPosMs + (standardIn.outMod->GetOutputTime() - standardIn.outMod->GetWrittenTime());
}

bool decode_header(unsigned long newhead, Frame* pfr)
{
	if ((newhead & 0xffe00000) != 0xffe00000)
		return false;
	if (!((newhead >> 17) & 3))
		return false;
	if (((newhead >> 12) & 0xf) == 0xf)
		return false;
	if (((newhead >> 10) & 0x3) == 0x3)
		return false;
	if ((newhead & 0xffff0000) == 0xfffe0000)
		return false;

	if (newhead & (1 << 20))
	{
		pfr->lsf = (newhead & (1 << 19)) ? 0x0 : 0x1;
		pfr->mpeg25 = 0;
	}
	else
	{
		pfr->lsf = 1;
		pfr->mpeg25 = 1;
	}

	pfr->lay = 4 - ((newhead >> 17) & 3);

	if (pfr->mpeg25)
		pfr->sampling_frequency = 6 + ((newhead >> 10) & 0x3);
	else
		pfr->sampling_frequency = ((newhead >> 10) & 0x3) + (pfr->lsf * 3);

	pfr->error_protection = ((newhead >> 16) & 0x1) ^ 0x1;
	pfr->bitrate_index = ((newhead >> 12) & 0xf);
	pfr->padding = ((newhead >> 9) & 0x1);
	pfr->extension = ((newhead >> 8) & 0x1);
	pfr->mode = ((newhead >> 6) & 0x3);
	pfr->mode_ext = ((newhead >> 4) & 0x3);
	pfr->copyright = ((newhead >> 3) & 0x1);
	pfr->original = ((newhead >> 2) & 0x1);
	pfr->emphasis = newhead & 0x3;

	pfr->stereo = (pfr->mode == MPG_MD_MONO) ? 1 : 2;

	if (!pfr->bitrate_index)
	{
		oldhead = 0;
		return false;
	}

	switch (pfr->lay)
	{
	case 1:
		pfr->jsbound = (pfr->mode == MPG_MD_JOINT_STEREO) ? (pfr->mode_ext << 2) + 4 : 32;
		pfr->framesize = GetBitrate(pfr->lsf, 1, pfr->bitrate_index) * 12000;
		pfr->framesize /= freqs[pfr->sampling_frequency];
		pfr->framesize = ((pfr->framesize + pfr->padding) << 2) - 4;
		break;
	case 2:
		GetLayer2(pfr);
		pfr->jsbound = (pfr->mode == MPG_MD_JOINT_STEREO) ? (pfr->mode_ext << 2) + 4 : pfr->II_sblimit;
		pfr->framesize = GetBitrate(pfr->lsf, 2, pfr->bitrate_index) * 144000;
		pfr->framesize /= freqs[pfr->sampling_frequency];
		pfr->framesize += pfr->padding - 4;
		break;
	case 3:
		if (pfr->lsf)
			ssize = (pfr->stereo == 1) ? 9 : 17;
		else
			ssize = (pfr->stereo == 1) ? 17 : 32;
		if (pfr->error_protection)
			ssize += 2;
		pfr->framesize = GetBitrate(pfr->lsf, 3, pfr->bitrate_index) * 144000;
		pfr->framesize /= freqs[pfr->sampling_frequency] << (pfr->lsf);
		pfr->framesize = pfr->framesize + pfr->padding - 4;
		break; 
	default:
		oldhead = 0;
		return false;
	}

	oldhead = newhead;
	return true;
}

bool Done_Stream()
{
	StreamManager* sManager = Args.getStreamManager();
	if (StreamInit)
		sManager->Close();
	StreamInit = false;
	return true;
}

void FillInputBuffer(int from)
{
	int rm = Args.CurrentPos % Args.InpBufFrames;
	if (rm == from)
	{
		bool res;
		Frame mFr(fr);
		for (int i = from; i < Args.InpBufFrames; i++)
		{
			res = ReadFrame(&mFr, true);

			mFr.result = res;
			frames->Add(mFr, i);
			if (!mFr.result)
				break;
		}
	}
}

unsigned long Frame2ms()
{
	if (GetBitrate(fr.lsf, fr.lay, fr.bitrate_index) != 0)
		if (InputMode == imHTTP)
			return (unsigned long) (8 * (fr.framesize + 5 - fr.padding) / GetBitrate(fr.lsf, fr.lay, fr.bitrate_index));
		else
			return (unsigned long) (Totalms() * (fr.framesize + 5 - fr.padding) / StreamSize);
	else
		return 0;
}

void FreeInputBuffer()
{
	delete frames;
	frames = NULL;
}

unsigned long Get1Bit(void)
{
	unsigned char rval;
	rval = *wordpointer << bitindex;
	bitindex++;
	wordpointer += (bitindex >> 3);
	bitindex &= 7;
	return rval >> 7;
}

int GetBitrate(int lsf, int lay, int bi)
{
	return BitRateIndex[lsf][lay - 1][bi];
}
unsigned long GetBits(int number_of_bits)
{
	unsigned long rval;
	if (!number_of_bits)
		return 0;
	{
		rval = wordpointer[0];
		rval <<= 8;
		rval |= wordpointer[1];
		rval <<= 8;
		rval |= wordpointer[2];
		rval <<= bitindex;
		rval &= 0xffffff;
		bitindex += number_of_bits;
		rval >>= (24 - number_of_bits);
		wordpointer += (bitindex >> 3);
		bitindex &= 7;
	}
	return rval;
}

unsigned long GetBitsFast(int number_of_bits)
{
	unsigned long rval;
	{
		rval = wordpointer[0];
		rval <<= 8;   
		rval |= wordpointer[1];
		rval <<= bitindex;
		rval &= 0xffff;
		bitindex += number_of_bits;
		rval >>= (16 - number_of_bits);
		wordpointer += (bitindex >> 3);
		bitindex &= 7;
	}
	return rval;
}

static void GetLayer2(Frame* pfr)
{
	static int Translate[3][2][16] =
	{
		{
		{0,2,2,2,2,2,2,0,0,0,1,1,1,1,1,0},
		{0,2,2,0,0,0,1,1,1,1,1,1,1,1,1,0}
		}, {
		{0,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0},
		{0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0}
		}, {
		{0,3,3,3,3,3,3,0,0,0,1,1,1,1,1,0},
		{0,3,3,0,0,0,1,1,1,1,1,1,1,1,1,0}
		}
	};

	int table, sblim;
	static int sblims[5] =
	{
		27, 30, 8, 12, 30
	};
	if (pfr->lsf)
		table = 4;
	else
		table = Translate[pfr->sampling_frequency][2 - pfr->stereo][pfr->bitrate_index];
	sblim = sblims[table];
	pfr->II_sblimit = sblim;
}

bool GetNextFrame()
{
	int rm = Args.CurrentPos % Args.InpBufFrames;
	fr.copy(frames->Get(rm));

	if (fr.result)
	{
		fsizeold = fsize;
		fsize = fr.framesize;

		bsbufold = bsbuf;
		bsnum = (bsnum + 1) % (TAILLEBS - 1);
		bsbuf = bsspace[bsnum] + 512;

		memcpy(bsbuf, fr.body, fr.framesize);

		bitindex = 0;
		wordpointer = bsbuf;
	}
	return fr.result;
}

bool head_read(unsigned char* hbuf, unsigned long* newhead)
{
	long numread;
	StreamManager* sManager = Args.getStreamManager();
	bool res = sManager->ReadF(hbuf, 4, (DWORD*)&numread);

	if (!res || numread != 4)
		return false;
	*newhead = ((unsigned long) hbuf[0] << 24) | ((unsigned long) hbuf[1] << 16) | ((unsigned long) hbuf[2] << 8) | (unsigned long) hbuf[3];
	return true;
}

bool InitInputBuffer()
{
	frames = new FrameManager(Args.InpBufFrames + 1);

	return true;
}

bool Init_Stream()
{
	X.h_id = 0;
	StreamSize = 0; 

	StreamManager* sManager = Args.getStreamManager();

	StreamSize = sManager->InitStream(&(Args.Seekable));

	InputMode = sManager->GetInputMode();
	//TODO A corriger
	//  if(StreamSize==0)
	//    return false;

	// Global initializations
	ibufnum = 0;fsize = 0;fsizeold = 0;bsnum = 0;oldhead = 0;firsthead = 0;

	StreamInit = true;    
	return true;
}

bool ReadFrame(Frame* pfr, bool readBody)
{
	long numread = 0;
	int i = 0;
	unsigned char hbuf[4];
	static unsigned long newhead;
	StreamManager* sManager = Args.getStreamManager();
	BOOL Res;

	bool read_again;
	do
	{
		read_again = false;
		if (!head_read(hbuf, &newhead))
			return false;

		if (oldhead != newhead || !oldhead)
		{
			if (!decode_header(newhead, pfr))
			{
				if (!firsthead)
				{
					if (newhead == ('R' << 24) + ('I' << 16) + ('F' << 8) + 'F')
					{
						if (sManager->SetFPointer(66, 0, FILE_CURRENT) == 0xFFFFFFFF)
							return false;
						read_again = true;
						continue;
					}
					if ((newhead & (('I' << 24) + ('D' << 16) + ('3' << 8))) == (('I' << 24) + ('D' << 16) + ('3' << 8)))
					{
						if (sManager->SetFPointer(2, 0, FILE_CURRENT) == 0xFFFFFFFF)
							return false;
						Res = sManager->ReadF(hbuf, 4, (DWORD *)&numread);

						if (!Res || numread != 4)
							return false;

						int id3v2size = (int)(hbuf[0] & 0x7f) * 0x200000 + (int)(hbuf[1] & 0x7f) * 0x4000 + (int)(hbuf[2] & 0x7f) * 0x80 + (int)(hbuf[3] & 0x7f);
						if (sManager->SetFPointer(id3v2size, 0, FILE_CURRENT) == 0xFFFFFFFF)
							return false;
						read_again = true;
						continue;
					}
					for (i = 0; i < 65536; i++)
					{
						memmove(&hbuf[0], &hbuf[1], 3);
						Res = sManager->ReadF(hbuf + 3, 1, (DWORD *)&numread);
						if (Res && numread == 0) // && sManager->GetInputMode() == imFile)
							return false;
						if (!Res || numread != 1)
							throw 1;
						newhead <<= 8;
						newhead |= hbuf[3];
						newhead &= 0xffffffff;
						if (decode_header(newhead, pfr))
							break;
					}
					if (decode_header(newhead, pfr))
					{
						if (!firsthead)
							firsthead = newhead;
						break;
					}
				}
				else
				{
					for (i = 0; i < 65536; i++)
					{
						memmove(&hbuf[0], &hbuf[1], 3);
						Res = sManager->ReadF(hbuf + 3, 1, (DWORD *)&numread);
						if (Res && numread == 0)
							return false;
						if (!Res || numread != 1)
							throw 1;
						newhead <<= 8;
						newhead |= hbuf[3];
						newhead &= 0xffffffff;
						if (decode_header(newhead, pfr))
							break;
					}
					TRACE(_T("i %d"), i);
					if (decode_header(newhead, pfr))
					{
						if (!firsthead)
							firsthead = newhead;
						break;
					}
				}
			}
			if (!firsthead)
				firsthead = newhead;
		}
		else
			decode_header(newhead, pfr);
	}
	while (read_again);
	bool res = true;
	if (readBody)
		res = ReadFrameBody(pfr);
	return res;
}

bool ReadFrameBody(Frame* pfr)
{
	long numread = 0;
	StreamManager* sManager = Args.getStreamManager();
	memset(pfr->body, 0, pfr->framesize); 
	bool Res = sManager->ReadF(pfr->body, pfr->framesize, (DWORD*)&numread);

	if (!Res && numread == 0)
		return false;
	if (!Res || numread != pfr->framesize)
		memset(pfr->body + numread, 0, pfr->framesize - numread); 

	if (X.h_id == 0)
	{
		if (pfr->lay == 3 && GetXingHeader(&X, pfr->body))
			X.h_id = 1;
		else
			X.h_id = 2;
	}

	return true;
}

void Reset_Stream()
{
	StreamManager* sManager = Args.getStreamManager();

	if (sManager->SetFPointer(0, 0, FILE_BEGIN) == 0xFFFFFFFF)
		return;
	ibufnum = 0; fsize = 0; fsizeold = 0; oldhead = 0;firsthead = 0; bitindex = 0; ssize = 0;

	bsbuf = bsspace[0];
	bsnum = 0;

	Args.CurrentPos = 0;
	Args.CurrentPosMs = 0;
}

bool Seek_Stream(int posInMs)
{
	StreamManager* sManager = Args.getStreamManager();

	unsigned long Posi;
	unsigned long XPosi;

	if (X.h_id != 1)
	{
		if (InputMode == imHTTP)
			Posi = (StreamSize / (fr.framesize + 5 - fr.padding)) * posInMs / standardIn.GetLength();
		else
			Posi = posInMs / Frame2ms();
		XPosi = fr.framesize * Posi;
	}
	else
	{
		Posi = X.frames * posInMs / standardIn.GetLength();
		XPosi = SeekPoint(TOC, X.bytes, (float)100 * posInMs / Totalms());
	}

	if (sManager->SetFPointer(XPosi, 0, FILE_BEGIN) == 0xFFFFFFFF)
		return false;
	if (XPosi == 0)
		firsthead = 0;

	Args.CurrentPos = Posi;
	Args.CurrentPosMs = Args.CurrentPos * Frame2ms();

	if (Args.CurrentPos % Args.InpBufFrames != 0)
		FillInputBuffer(Args.CurrentPos % Args.InpBufFrames);
	return true;
}

void SetPointer(long backstep)
{
	wordpointer = bsbuf + ssize - backstep;
	if (backstep)
		memmove(wordpointer, bsbufold + fsizeold - backstep, backstep);
	bitindex = 0;
}

unsigned long Totalms()
{
	if ((fr.framesize + 5 - fr.padding) != 0)
		return (unsigned long) ((8 * StreamSize) / GetBitrate(fr.lsf, fr.lay, fr.bitrate_index));
	else
		return 0;
}

